#version 110
#define float4 vec4
#define float3 vec3
#define float2 vec2
#define oUV gl_TexCoord[0]
#define tex3D texture3D
#define tex2D texture2D
#define tex1D texture1D

uniform sampler2D texture2d_1;
uniform sampler2D texture2d_velocities;
uniform sampler2D texture2d_2;
uniform sampler2D texture2d_random;
uniform sampler1D texture1d_dsp;

/*				uniform sampler1D texture_transfer_function;
uniform sampler1D texture_palette_function;


uniform float3 VolumeSize;
uniform float3 RelativeSize;
uniform float3 Registration_Offset;
uniform float pet_alpha_blending;
uniform float3 MousePos;
uniform int Projection_mode;
uniform float3 InVolumePosition;
uniform float3 Windowing_Levels;

uniform float isosurface;
uniform float Sharpening;

*/
uniform float time;

uniform float Limit;
uniform float Flo;

uniform float PosY;
uniform float3 Speed;


float penta(vec2 coords) //pentagonal shape
{
	float feather = 0.4;
	float scale = float(5) - 1.3;
	vec4  HS0 = vec4( 1.0,         0.0,         0.0,  1.0);
	vec4  HS1 = vec4( 0.309016994, 0.951056516, 0.0,  1.0);
	vec4  HS2 = vec4(-0.809016994, 0.587785252, 0.0,  1.0);
	vec4  HS3 = vec4(-0.809016994,-0.587785252, 0.0,  1.0);
	vec4  HS4 = vec4( 0.309016994,-0.951056516, 0.0,  1.0);
	vec4  HS5 = vec4( 0.0        ,0.0         , 1.0,  1.0);
	
	vec4  one = vec4( 1.0 );
	
	vec4 P = vec4((coords),vec2(scale, scale)); 
	
	vec4 dist = vec4(0.0);
	float inorout = -4.0;
	
	dist.x = dot( P, HS0 );
	dist.y = dot( P, HS1 );
	dist.z = dot( P, HS2 );
	dist.w = dot( P, HS3 );
	
	dist = smoothstep( -feather, feather, dist );
	
	inorout += dot( dist, one );
	
	dist.x = dot( P, HS4 );
	dist.y = HS5.w - abs( P.z );
	
	dist = smoothstep( -feather, feather, dist );
	inorout += dist.x;
	
	return clamp( inorout, 0.0, 1.0 );
}


void main (void) 
{




	//float ff=tex2D (texture2d_1,oUV.xy).x;
	//ff=abs (ff-cl.x);
	//ff=0.5+0.5*sin(ff*10000.0);
	//cl=ff*vec4 (1.0);



	/*


	float PI=3.1415926535;
	float2 UV=oUV.xy;

	UV-=float2 (0.5,0.5);
	UV*=2.0;


	float3 DirV =float3 (UV.x,UV.y,0.6);
	float lgn=length (DirV);
	DirV/=lgn;

	UV.xy=UV.xy+(DirV.xy-UV.xy)*-0.0;
	UV*=0.5;
	UV+=float2 (0.5,0.5);
	*/
	float2 UV=oUV.xy;
	float4 cl=tex2D (texture2d_1,UV.xy);

	cl=float4 (0.0);
	float3 Direction=tex2D (texture2d_velocities,UV.xy).xyz;
	//Direction.xy=float2 (0.5);
	Direction.xyz-=float3 (0.5);
	Direction*=2.0;

	float alpha=1.0*length (Direction.xyz);
	alpha=clamp (alpha,0.0,1.0);
	//alpha=1-alpha;
	//alpha*=alpha;
	//alpha=1-alpha;

	//alpha*=alpha;
	//alpha=0.1;
	Direction*=0.01;
	if (alpha>0.01)
	{
		for (int t=0;t<10;t++) { 
			UV.xy-=Direction.xy;
			cl+=tex2D (texture2d_1,UV.xy);
		};
		cl*=1.0/10.0;
		//cl.x+=0.15*alpha;
		//=float4 (1.0,0.0,0.0,1.0)*alpha;
	}
	else
		cl=tex2D (texture2d_1,UV.xy);

	float4 clnow=tex2D( texture2d_1,oUV.xy);

	cl=cl+(clnow-cl)*0.5;

	UV=oUV.xy;



	vec3 CC;
	float didf=0.001;
	CC.r= (tex2D(texture2d_1,UV.xy).x);
	CC.g= (tex2D(texture2d_1,vec2 (didf,0.0)+UV.xy).y);
	CC.b=(tex2D(texture2d_1,vec2 (-didf,0.0)+UV.xy).z);



	 CC.xyz=vec3 (CC.r,CC.g,CC.b);



	// blur effect
	float lgn2=length (float2 (2.0,2.0)*(UV.xy-float2 (0.5)));
	lgn2*=lgn2;
	
	
	//lgn2=1-lgn2;
	//pow(lgn2,1.8);
	int count=0;
	for (int y=-8;y<9;y++) {
		for (int x=-8;x<9;x++){
			count++;

			float2 dd=float2 (x,y);
			//lgn2=1.0;
			float2 Dist=float2 (x,y)*0.0012*lgn2;
			Dist=dd*0.0002*lgn2;
			cl+=tex2D(texture2d_1,UV.xy+Dist)*(1.0-0.5*lgn2);

		}
	}
	cl/=float (count)*(lgn2+(1.0-lgn2)*0.85);
//	cl.xyz+=(CC-cl.xyz)*clamp (1.0-4*lgn2,0.0,1.0);
	//cl/=float (count);


	vec4 cll=cl;
	vec4 blurcll=cl;
	//blurcll=vec4 (lgn2);









	/*


	//Depth blurring

	float dpth=0.0;
	count=0;
	float Limit2=1.0-Limit;
	for (int y=-4;y<5;y++) {
	for (int x=-4;x<5;x++){
	count++;
	float2 dd=float2 (x,y)*0.7*Limit2;

	//dd=ray.xy*5.0;

	float2 Dist=dd*0.0018;
	dpth+=tex2D(texture2d_2,UV.xy+Dist).x;
	}
	}
	dpth/=float (count);
	//dpth=sin(dpth*3.14159);
	//dpth+=0.1;
	dpth=pow(dpth,126.0);
	//dpth+=Limit;
	dpth=1.0-1.0*dpth;
	//if (dpth<0.7) dpth=0.0;
	count=0;
	cl=vec4(0.0);
	dpth=clamp(dpth,0.0,1.0);

	dpth=Limit+((1.0-Limit)-(Limit))*dpth;
	dpth*=Flo;
	//dpth=1.0;

	float vel=tex2D(texture2d_velocities,UV.xy).x;
	if (dpth>0.02)
	{ 
	for (int y=-4;y<5;y++) {
	for (int x=-4;x<5;x++){
	count++;

	float2 dd=float2 (x,y)*0.7;//;*vec2 (3.0,3.0);

	//float2 dd2=float((x+4)*9+(y+4))*float2 (-1.0,1.0)*0.4;
	//dd=dd+(dd2-dd)*-vel*0.4;


	float2 Dist=dd*0.0018*dpth;
	cl+=tex2D(texture2d_1,UV.xy+Dist);
	//cl.x=dpth;
	}
	}

	cl/=float (count);
	}
	else
	cl=tex2D(texture2d_1,UV.xy);

	*/

	//blurcll=cl;




	//cl*=0.4;

	//cl+=tex2D(texture2d_velocities,UV.xy)*0.5;


	//cl=tex2D(texture2d_1,UV.xy);
	//cl=vec4 (dpth);



	cl=cll;
	cl=vec4 (tex2D(texture2d_1,UV.xy).xyzw);




	float divv=tex1D (texture1d_dsp,-time*0.15+float(int(time*1.0))*0.4+0.5+UV.y*1.0).x*1.28;
	divv+=tex1D (texture1d_dsp,time*0.1+float(int(time*1.0))*0.2+UV.y*0.034).x*0.75;
	divv*=divv;



	divv*=0.35;

	divv*=UV.y;
	//float divv2=tex1D (texture1d_dsp,time*0.02+UV.y*0.1).x;

	//divv*=divv2;
	//divv*=divv2;
	//divv*=
	float beat;
	beat=0.5+0.5*sin(2.0*time*3.1415926535+1.2);
	beat*=1.01;
	beat=pow(beat,9.0);
	beat=pow(beat,9.0);
	beat=clamp (beat,0.0,1.0);
	//divv=beat*0.1;
	divv*=beat*2.0+0.32;
	divv*=0.9;
	float dif=0.002;
	dif=divv+0.002*UV.y;
	//+0.005*beat;
	//dif=0.0;
	dif*=0.0;
	dif=0.002;
	//dif=0.01*sin(time*8);
	cl.r= (tex2D(texture2d_1,UV.xy).x);
	cl.g= (tex2D(texture2d_1,vec2 (dif,0.0)+UV.xy).y);
	cl.b=(tex2D(texture2d_1,vec2 (-dif,0.0)+UV.xy).z);



	vec4 clg=vec4 ((cl.r+cl.g+cl.b)*0.333)*vec4 (1.4,0.5,0.3,1.0);
	 clg.xyz=vec3 (cl.r,cl.g,cl.b);
	//cl+=vec4 (beat)*1.0;

	//cl=cl+(clg-cl)*beat*0.5;

	//cl=clln;

	//if (UV.x>0.5) cl=vec4 (tex2D(texture2d_1,UV.xy).xyzw);
	//cl=tex2D(texture2d_1,UV.xy+vec2 (divv,0.0)).xyzw;
	//cl=vec4 (divv)*200.0;
	//D (texture).xyzw);

	//cl=vec4 (1.0);




	cl=vec4 (tex2D(texture2d_1,UV.xy).xyzw)*1.0;


	//  sobel
	float fdiff=abs(tex2D(texture2d_1,UV.xy+vec2 (-0.001,0.0)).x-tex2D(texture2d_1,UV.xy+vec2 (0.001,0.0)).x);
	 //fdiff+=abs(tex2D(texture2d_1,UV.xyy+vec2 (0.0,-0.001)).x-tex2D(texture2d_1,UV.xy+vec2 (0.0,0.001)).x);
	 fdiff=clamp (fdiff,0.0,1.0);
	cl=vec4 (fdiff);

	
	//fdiff=0.0;

	// blur effect
	//lgn2=1-lgn2;
	//pow(lgn2,1.8);
	{
		int count=0;
		for (int y=-6;y<7;y++) {
			for (int x=-6;x<7;x++){
				count++;

				float2 dd=float2 (x,y);
				//lgn2=1.0;
				float2 Dist=float2 (x,y)*0.012*lgn2;
				Dist=dd*0.00011*fdiff;
				cl+=tex2D(texture2d_1,UV.xy+Dist)*(1.0-0.5*lgn2);

			}
		}
		cl/=float (count);

	}
	//cl=vec4 (fdiff);

	//cl.xy=tex2D(texture2d_1,vec2 (0.5)+1.0*(UV.xy-vec2 (0.5))).xy;
	//cl.y+=tex2D(texture2d_1,vec2 (0.5)+0.98*(UV.xy-vec2 (0.5))).y;
	//cl.z=tex2D(texture2d_1,vec2 (0.5)+0.96*(UV.xy-vec2 (0.5))).z;


	//cl=cll;


	//cl=tex2D(texture2d_1,UV.xy);


	float lgn3=length (float2 (2.0,2.2)*(UV.xy-float2 (0.5)));
	lgn3*=lgn3;


	cl=blurcll*(1.0-0.7*lgn3);
	


	/*
	{
		int samples = 3; //samples on the first ring
int rings = 5;

	float fc=0.0;
	vec4 total=vec4(0.0);
int ringsamples;
float blur=1.0;
float bias = UV.x;
float w=0.003;
float h=0.003;

	for (int i=1;i<6;i++){

		ringsamples=i *samples;
	for (int j=0;j<ringsamples;j++) { 

		float step=3.14159265*2.0/float(ringsamples);


	float pw = (cos(float(j)*step)*float(i));
			float ph = (sin(float(j)*step)*float(i));
			float p = 1.0;

			{ 
			p = penta(vec2(pw,ph));
			}

		fc+=p;

		total+=tex2D(texture2d_1, UV.xy + vec2(pw*w,ph*h),blur)*mix(1.0,(float(i))/(float(rings)),bias)*p;  

			
	}
	
	}


	
	total/=fc;
	cl=total;
	
	}
	
	*/


	 cl.xyz+=(cl.yyy*vec3 (0.4,0.6,1.0)-cl.xyz)*0.9*(1.0-clamp ((time-0.5)*0.3,0.0,1.0));


	gl_FragData[0]=cl;
	gl_FragData[1]=cl;

}














