#version 120
#define float4 vec4
#define float3 vec3
#define float2 vec2
#define oUV gl_TexCoord[0]
#define tex3D texture3D
#define tex2D texture2D
#define tex1D texture1D

#define SSAO se= ep+ddd*sign (dot (ray,norm))*ray; occluderFragment = tex2D(texture2d_1,se.xy); shadow=occluderFragment.w;occluderFragment.a=tex2D (texture2d_2,se.xy).x;occNorm = (occluderFragment.xyz*2.0)-vec3 (1.0);depthDifference = 40.0*(depth-occluderFragment.a);normDiff = 1.0-1.0*dot(occNorm,norm); addition=step(0.00002,depthDifference)*normDiff*(1.0-smoothstep(0.0002,0.20,depthDifference)); bl += addition;







				uniform sampler2D texture2d_1;
				uniform sampler2D texture2d_1f;
				uniform sampler2D texture2d_2;
				uniform sampler2D texture2d_3;
				uniform sampler2D texture2d_projected;
				uniform sampler2D texture2d_random;
				uniform float Limit;
uniform mat4 ProjectionMatrix;
uniform float time;







// hash

float hash( float n )
{
    return fract(sin(n)*43758.5453);
}

// noise

float noise( in vec3 x )
{
    vec3 p = floor(x);
    vec3 f = fract(x);

    f = f*f*(3.0-2.0*f);
    float n = p.x + p.y*57.0 + 113.0*p.z;
    return mix(mix(mix( hash(n+  0.0), hash(n+  1.0),f.x),
                   mix( hash(n+ 57.0), hash(n+ 58.0),f.x),f.y),
               mix(mix( hash(n+113.0), hash(n+114.0),f.x),
                   mix( hash(n+170.0), hash(n+171.0),f.x),f.y),f.z);
}

// map


vec4 map( in vec3 p )
{
	//altitude
	float d = -0.005 - p.y + sin(time) / 4.0;
	d=0.05-p.y;
	//wind
	vec3 q = p - vec3(-0.4,0.0,sin(time)/1500.0 - 0.5) * time*0.1;
	 q = p + vec3(0.0,0.0,0.5) * time*0.13*0.5;


	 float f;
	q*=4.0;
    f  = 0.5000*noise( q ); q = q*2.02;
    f += 0.2500*noise( q ); q = q*2.03;
    f += 0.1250*noise( q ); q = q*2.01;
    f += 0.0625*noise( q );
	//f=pow(f,1.2);
	//density
	d += 4.0 * f;

	d = clamp( d, 0.0, 1.0 );
	
	vec4 res = vec4( d );

	// diffuse is here actually
//	res.xyz = mix( 1.15*vec3(1.0,0.95,0.8), vec3(0.7,0.7,0.7), res.x );
	res.xyz = mix( 1.1*vec3(1.0,1.1,1.2), vec3(0.7,0.7,0.7), res.x );
	
	return res;
}

// sundir

vec3 sundir = vec3(-1.0,-1.0,0.0);

// raymarch
float steps=0.0;

vec4 raymarch( in vec3 ro, in vec3 rd )
{
	vec4 sum = vec4(0, 0, 0, 0);
		//ro.xy+=CamPos.xy*10.0;
	//ro.x-=CamPos.x;
	float t = 0.0;
	for(int i=0; i<10; i++)
	{
		
		if( sum.a > 0.99 ) continue;
		steps+=0.1;
		vec3 pos = ro + t*rd;
		vec4 col = map( pos );
		
		#if 1
		float dif =  clamp((col.w - map(pos+0.3*sundir).w)/0.6, 0.0, 1.0 );
		float constrast = 0.5;
		//fake for now, but will change soon
		vec3 skylighting = vec3(0.4,0.88,1.2)*0.1 + 0.0 ;
		vec3 sunlighting = vec3(1.0,1.0,1.0)*0.7 + 0.0;
    
		
		vec3 lin = sunlighting + skylighting;
		col.xyz *= lin;
		col.xyz *= pow(col.xyz, vec3(constrast));
		#endif
		
		col.a *= 0.25;
		col.rgb *= col.a;

		sum = sum + col*(1.0 - sum.a);	

        #if 0
		t += 0.1;
		#else
		t += max(0.1,0.02*t)*1.0;
		#endif
	}

	sum.xyz /= (0.001+sum.w);

	return clamp( sum, 0.0, 1.0 );
}



vec2 rhash(vec2 uv) {
	const mat2 t = mat2(.12121212,.13131313,-.13131313,.12121212);
	const vec2 s = vec2(1e4, 1e6);
	uv *= t;
	uv *= s;
	return  fract(fract(uv/s)*uv);
}



float voronoi(const in vec2 uv)
{
	vec2 p = floor(uv);
	vec2 f = fract(uv);
	float v = 0.;
	for( int j=-1; j<=1; j++ )
		for( int i=-1; i<=1; i++ )
		{
			vec2 b = vec2(i, j);
			vec2 r = b - f + rhash(p + b);
			v += 1./pow(dot(r,r),8.);
		}
		return pow(1./v, 0.0625);
}


void main (void) 
{
float4 cl;
float depth;



// random vector
vec3 fres = normalize((texture2D(texture2d_random,oUV.xy*2.0+float2 (time*1.0)).xyz*2.0) - vec3(1.0));

// depth 
	depth=tex2D (texture2d_2,oUV.xy).x;


vec3 ep=vec3 (oUV.xy,depth);
float bl=0.0;
vec3 ray;
vec3 se;
vec3 occNorm;
float depthDifference,normDiff;
float3 norm=((tex2D (texture2d_1,oUV.xy).xyz-0.5)*2.0);
float4 GlobalIllumination=float4 (0.0);
bl=1.0;



float ddd=0.027;
float shadow;
float addition;
vec4 occluderFragment;

	//for (int i=0;i<24;i++) 

bool occluder;
occluder=true;
if (tex2D(texture2d_1,oUV.xy).w<0.9) occluder=false;
occluder=true;

//occluder=true;

if (occluder) { 


//1
ray= reflect (vec3(0.53812504, 0.18565957, -0.43192),fres);
SSAO
//2
ray= reflect (vec3(0.13790712, 0.24864247, 0.44301823),fres);
SSAO
//3
ray= reflect (vec3(0.33715037, 0.56794053, -0.005789503),fres);
SSAO
//4
ray= reflect ( vec3(-0.6999805, -0.04511441, -0.0019965635),fres);
SSAO
//5
ray= reflect ( vec3(0.06896307, -0.15983082, -0.85477847),fres);
SSAO
//6
ray= reflect (vec3(0.056099437, 0.006954967, -0.1843352),fres);
SSAO
//7	
ray= reflect ( vec3(-0.014653638, 0.14027752, 0.0762037),fres);
SSAO
//8
ray= reflect ( vec3(0.010019933, -0.1924225, -0.034443386),fres);
SSAO	
//9	
ray= reflect ( vec3(-0.35775623, -0.5301969, -0.43581226),fres);
SSAO
//10	
ray= reflect ( vec3(-0.3169221, 0.106360726, 0.015860917),fres);
SSAO
//11
ray= reflect (  vec3(0.010350345, -0.58698344, 0.0046293875),fres);
SSAO
//12 

ray= reflect ( vec3(-0.08972908, -0.49408212, 0.3287904),fres);
SSAO
//13
ray= reflect ( vec3(0.7119986, -0.0154690035, -0.09183723),fres);
SSAO
//14
ray= reflect ( vec3(-0.053382345, 0.059675813, -0.5411899),fres);
SSAO
//15
ray= reflect (  vec3(0.035267662, -0.063188605, 0.54602677),fres);
SSAO
//16

ray= reflect (   vec3(-0.47761092, 0.2847911, -0.0271716),fres);
SSAO
//17 
ray= reflect ( vec3 ( -0.559644, -0.554896, -0.61554),fres);
SSAO

//18
ray= reflect (vec3 ( 0.65487, 0.496541, -0.569729),fres);
SSAO
//19 
ray= reflect (vec3 ( 0.382319, -0.719566, 0.579705),fres);
SSAO

//20
ray= reflect ( vec3 ( 0.800123, 0.344357, 0.491142),fres);
SSAO
//21
ray= reflect (  vec3 ( 0.426191, -0.414526, 0.804071),fres);
SSAO




bl=1.0-bl*0.09*0.28*1.9;
//bl=1.0-bl*0.09*0.80;
//bl*=bl;


bl=clamp (bl,0.0,1.0);
//bl=0.1;
}

//bl=0.0;
norm=normalize(norm);
// SS lighting
float ccl=1.0-0.0*pow(dot (norm,float3 (0.0,0.0,1.0)),2.0);	


float rad=1.3-2.0*length (oUV.xy-vec2 (0.5));
rad=clamp (rad,0.0,1.0);




vec3 NewCol=vec3 (0.1,0.15,0.2);

NewCol+=(vec3 (0.2,0.5,0.8)-NewCol)*0.0*clamp ((time-39)*0.2,0.0,1.0);

vec3 seacolor=NewCol*rad;
 //seacolor=vec3 (0.2,0.1,0.0)*rad;
vec3 Sea=(seacolor*oUV.y*(0.0+1.0*bl)+1.0*tex2D (texture2d_3,oUV.xy).xyz)*bl;


Sea=seacolor*(vec3(1.0)-tex2D (texture2d_3,oUV.xy).xyz);
//Sea=tex2D (texture2d_3,oUV.xy).xyz;



gl_FragData[0].xyz=bl*tex2D (texture2d_1,oUV.xy).xyz;
gl_FragData[0].xyz=vec3(bl);

gl_FragData[0].xyz=tex2D (texture2d_3,oUV.xy).xyz*bl;
gl_FragData[0].xyz=tex2D (texture2d_3,oUV.xy).xyz;
//gl_FragData[0].xyz=tex2D (texture2d_1,oUV.xy).xyz;
gl_FragData[0].xyz=Sea;

//*tex2D (texture2d_3,oUV.xy).xyz;












{
	
	vec2 _resolution=vec2 (600)*1.5;
	//1920.0,1280.0);

	vec2 q = gl_FragCoord.xy/ _resolution.xy;
	vec2 p = -1.0 + 2.0*q;
	p.x *= _resolution.x/ _resolution.y;
	vec2 mo = -1.0 + 2.0 / _resolution.xy;
	
	    // camera
    	vec3 ro = 4.0*normalize(vec3(cos(4.00-1.5*mo.x), 0.7+(mo.y+1.0), sin(2.75-3.0*mo.x)));
    	 ro = 2.2*normalize(vec3(mo.x+3.5, (mo.y+5), 1.0+4.0*mo.x));

		
		vec3 ta = vec3(0.0, 0.0, 1.0);
    	vec3 ww = normalize( ta - ro);
    	vec3 uu = normalize(cross( vec3(0.0,1.0,0.0), ww ));
    	vec3 vv = normalize(cross(ww,uu));
    	vec3 rd = normalize( p.x*uu*1.0 + p.y*vv*1.0 + 1.0*ww );
	
	vec4 res = raymarch( ro, rd );

	float sun = clamp( dot(sundir,rd), 0.0, 1.0 );
	vec3 col = vec3(0.6,0.63,0.7) - rd.y*0.2*vec3(0.5,0.5,1.0) + 0.1 * 0.8;
	col += vec3(1.3,1.22,0.65)*sun * 0.6;
	col *= 0.95;
	
	col = mix( col, res.xyz, res.w );
	col=vec3 (col.x);
	//col += 0.6*vec3(0.8,0.55,0.3)*pow( 0.5+sun, 1.0 );
	//col += 0.3*vec3(0.6,0.8,1.0)*pow( 0.5+sun, 1.0 );
	//col += 0.3*vec3(0.7,0.6,0.6)*pow( 0.5+sun, 1.0 );
	

	
	
	//col += 0.4*vec3(0.4,0.4,0.4)*pow( 1.0-sun, 1.0 );
	col *= col;
	col *= col*2;
	//col=pow(col,1.5);
	col = col;
	
	gl_FragData[0] = vec4( col, 1.0 );

	float fc=1.0-clamp (1.4*(steps-5.3),0.0,1.0);
	fc+=0.0;
	

//fc=0.3;
fc=1.0;

fc=1.0-q.y-0.44;
fc=clamp (fc,0.0,1.0);

fc=1.0-1.0*pow(1.0-fc-gl_FragData[0].x*0.5,1.0);


fc=q.y*5+gl_FragData[0].x;
fc=clamp (fc,0.0,1.0);
//gl_FragData[0].xyz*=gl_FragData[0].xyz;
//fc=1;
float fcc=0.15+clamp ((time-9-(1-q.x)*3.0)*0.2,0.0,1.0);
 fcc=clamp (fcc,0.0,1.0);
 fcc-=clamp ((time-16-(1-q.x)*3.0)*0.2,0.0,1.0);
 fcc+=clamp ((time-40)*0.2,0.0,1.0);
 fcc-=clamp ((time-46-(1-q.x)*0.0)*1.0,0.0,1.0);
 //c+=clamp ((time-52)*0.5,0.0,1.0);
 fcc=clamp (fcc,0.0,1.0);
 fcc=10.8;
//fc=1.0;
 vec3 Fog=gl_FragData[0].xyz*0.5;
 //Fog=Fog*vec3 (0.0,0.0,0.0);

 float sundist=1.0-length(vec2 (1.5,1.0)*(oUV.st-vec2 (0.2,0.5)));
 
 sundist=clamp (sundist*1.1,0.0,1.0);
 sundist=pow(sundist,5.0);
 

 float sundist2=1.0-length(vec2 (1.5,1.0)*(oUV.st-vec2 (0.8,0.5)));
 
 sundist2=clamp (sundist2*1.1,0.0,1.0);
 sundist2=pow(sundist2,5.0);
 

 vec3 Sun=vec3 (0.9,0.5,0.2)*sundist2+vec3 (0.3,0.5,0.8)*sundist;
Sun*=0.5+Fog*2.0;

// seacolor+=Sun;
// seacolor*=clamp ((time)*0.2,0.0,1.0);

Sun=seacolor+Fog*0.2;;
gl_FragData[0].xyz=gl_FragData[0].xyz*1.5*seacolor*(vec3(1.0)-tex2D (texture2d_3,oUV.xy).xyz);
 //gl_FragData[0].xyz*=0.5+1.0*bl;
 

 //bl+=(1-bl)*0.5;
 //seacolor*=(1+Fog.x*2)*1.0;
 seacolor*=0.0;
 
 gl_FragData[0].xyz=seacolor*1.0*bl*(vec3(1.0)-1.0*tex2D (texture2d_3,oUV.xy).xyz);
 gl_FragData[0].xyz=seacolor;
 gl_FragData[0].xyz+=(0.25*bl*vec3 (tex2D (texture2d_3,oUV.xy).xyz)-seacolor)*
	 clamp (+0.5+1.5*tex2D (texture2d_3,oUV.xy).x,0.0,1.0);


  gl_FragData[0].xyz=bl*tex2D (texture2d_3,oUV.xy).xyz;
  vec3 SeaC=vec3 (0.0,0.11,0.13)*2.0;
 
  float pttime=time*3.0;
  /*
  float fct=voronoi (3.0*oUV.xy+0.132*vec2(pttime,pttime*0.2)).x;
 
  fct*=voronoi (4.3*oUV.xy-0.05*vec2(pttime,pttime*0.03)).x;
 //fct*=voronoi (2.4*oUV.xy-0.05*vec2(pttime*1.2,pttime*0.42)).x;
 fct=pow (fct*4.3,2.0);
 fct*=0.5*clamp (time*0.2,0.0,1.0);
 fct*=(1.0-clamp ((time-7.0)*0.6,0.0,1.0));
 */
 
 
 //fct+=1.0;
 //fct=0.0;
  gl_FragData[0].xyz+=(SeaC+(vec3 (0.0,0.0,0.0)-SeaC)*(oUV.x));
  //gl_FragData[0].xyz+=gl_FragData[0].y*fct*vec3 (0.2,0.3,0.4);
  //*(oUV.x);
  //gl_FragData[0].xyz*=vec3 (fct);

  gl_FragData[0].xyz*=1.0-clamp ((time-14.0)*0.2,0.0,1.0);
  gl_FragData[0].xyz*=clamp ((time-0.0)*0.7,0.0,1.0);

 
  

 // gl_FragData[0].xyz=vec3 (fct);
/*
 gl_FragData[0].xyz=Sun-1.0*vec3 (1-bl)*(vec3 (0.0)+tex2D (texture2d_3,oUV.xy).xyz);
gl_FragData[0].xyz=Sun*5.0*vec3 (bl)*(vec3 (0.0)+tex2D (texture2d_3,oUV.xy).xyz);



float fccc=tex2D (texture2d_3,oUV.xy).x;
Sun=vec3 (Sun.x)*1.0;

gl_FragData[0].xyz=Sun*0+vec3 (bl)*(vec3 (0.5)-tex2D (texture2d_3,oUV.xy).xyz);
gl_FragData[0].xyz=Sun*1.5*bl*(vec3 (1.0)-tex2D (texture2d_3,oUV.xy).xyz*1);



gl_FragData[0].xyz=Sun*53.0*bl*(tex2D (texture2d_3,oUV.xy).xyz);
	
gl_FragData[0].xyz*=Sun*1.5;




gl_FragData[0].xyz+=(Sun-gl_FragData[0].xyz)*0.6*(1.0-gl_FragData[0].x);
float lights=1-clamp ((time-14)*0.2,0.0,1.0);

gl_FragData[0].xyz+=vec3 (0.7,0.8,1.3)*pow(1-oUV.y,3.0)*2.0*Sun.x*lights;
gl_FragData[0].xyz+=vec3 (1.7,1.4,1.0)*pow(1.15*length (oUV.xy-vec2 (0.5)),5.0)*9.5*Sun.x*lights;

//if (tex2D (texture2d_3,oUV.xy).w>0.99)	gl_FragData[0]*=0.5;

//gl_FragData[0].xyz=vec3(bl);
//*sundist;
gl_FragData[0].w=1;
//*5.0*vec3 (bl)*(vec3 (0.0)+tex2D (texture2d_3,oUV.xy).xyz);

 
 

	//gl_FragData[0].xyz=tex2D (texture2d_3,oUV.xy).www;
 
 //gl_FragData[0].xyz=vec3 (1.0-tex2D (texture2d_3,oUV.xy).xyz);


 //*1.0*bl*(vec3(1.0)-1.0*tex2D (texture2d_3,oUV.xy).xyz);
 
 
 //gl_FragData[0].xyz+=(Sun-gl_FragData[0].xyz)*sundist;


gl_FragData[0].xyz*=clamp ((time-(-10.0))*0.1,0.0,1.0);
gl_FragData[0].xyz*=1-clamp ((time-20)*0.15,0.0,1.0);

*/

//gl_FragData[0].xyz+=clamp (time*0.3,0.0,1.0)* vec3 (0.7,0.5,0.3)*pow(1.15*length (oUV.yx-vec2 (0.5)),3.0)*4.5*Sun.x*lights;


 //gl_FragData[0].xyz*=clamp (3*oUV.y,0.0,2.0);
 //gl_FragData[0].xyz+=(Fog-gl_FragData[0].xyz)*(0.4*clamp ((1.0-0.2*bl-1.5*oUV.y-gl_FragData[0].x*4),0.0,1.0));
// gl_FragData[0].xyz=gl_FragData[0].xyz*1.0;
 //*seacolor*(vec3(1.0)-tex2D (texture2d_3,oUV.xy).xyz);

 
 gl_FragData[0].w=1.0;
 
 }



 float fs=clamp ((time-7.0-oUV.y*0.0)*0.15,0.0,1.0);
 gl_FragData[0].xyz+=(gl_FragData[0].yyy-gl_FragData[0].xyz)*fs;
  gl_FragData[0].xyz+=(gl_FragData[0].yyy-gl_FragData[0].xyz)*0.9*(1.0-clamp ((time-0.5)*0.3,0.0,1.0));

}














